package bedatest;

import com.steema.teechart.DateTime;
import com.steema.teechart.drawing.Color;
import com.steema.teechart.drawing.DashStyle;
import com.steema.teechart.styles.FastLine;
import com.steema.teechart.styles.TreatNullsStyle;
import com.steema.teechart.tools.CursorTool;
import com.steema.teechart.tools.CursorTool.CursorEvent;
import com.steema.teechart.tools.CursorToolStyle;
import com.steema.teechart.tools.NearestPoint;
import com.steema.teechart.tools.NearestPointStyle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.Date;
import javax.swing.SwingWorker;

public class BedaFrame extends javax.swing.JFrame {


    public BedaFrame() {
        initComponents();    
              
        chart1.getAspect().setView3D(false);
        chart1.getAspect().setSmoothingMode(false);
        chart1.getAspect().setTextSmooth(false);
        chart1.getLegend().setVisible(false);
        chart1.getHeader().setVisible(true);

        chart1.getZoom().setAnimated(false);
        chart1.getZoom().getBrush().setColor(Color.BLUE);
        chart1.getZoom().getBrush().setSolid(true);
        chart1.getZoom().getPen().setColor(Color.RED);
        chart1.getZoom().getPen().setWidth(3);
        chart1.getZoom().setHistory(true);
        
        nearestPointTool.setStyle(NearestPointStyle.CIRCLE);
        nearestPointTool.setDrawLine(false);        
        chart1.getTools().add(nearestPointTool);                 
        chart1.addMouseMotionListener(new MouseMotionAdapter() {
            public void mouseMoved(MouseEvent e) {                             
                
             /*   if(!chart1.getSeries().isEmpty()) {
                    date.setTime((long)chart1.getAxes().getBottom().calcPosPoint(e.getX()));                    
                    System.out.println("Mouse position values: X:" + df.format(date) + "   Y:" + chart1.getAxes().getLeft().calcPosPoint(e.getY()));                              
                    
                    SeriesXYPoint point = lineSeries.getPoint(nearestPointTool.getNearestPoint(new Point(e.getX(),e.getY())));
                    date.setTime((long)point.getX());
                    System.out.println("Mouse position nearest values: X:" + df.format(date) + "   Y:" + point.getY());                              
                }                */
            }
        });                       
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        button = new javax.swing.JButton();
        chart1 = new com.steema.teechart.TChart();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        button.setText("Load data");
        button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActionPerformed(evt);
            }
        });

        chart1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        chart1.setText("");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(chart1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(button)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(button)
                .addGap(37, 37, 37)
                .addComponent(chart1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonActionPerformed
                     
        chart1.removeAllSeries();
        lineSeries.clear();
        lineSeries.getXValues().setDateTime(true);
        //lineSeries.setDrawAllPoints(false);   
        //lineSeries.setDrawAllPointsStyle(DrawAllPointsStyle.MINMAX);   
        lineSeries.setTreatNulls(TreatNullsStyle.DONOTPAINT);
       
        button.setEnabled(false);

        LocalDate ldVon = LocalDate.of(2006, 02, 14);
        LocalDate ldBis = LocalDate.of(2006, 02, 15);
        
   
   
        //Date dateFrom = Date.from(lgdpVon.getDate().atStartOfDay(ZoneId.systemDefault()).toInstant());
        //Date dateTo = Date.from(lgdpBis.getDate().atStartOfDay(ZoneId.systemDefault()).toInstant());
        
        Date dateFrom =  Date.from(ldVon.atStartOfDay(ZoneId.systemDefault()).toInstant());
        Date dateTo = Date.from(ldBis.atStartOfDay(ZoneId.systemDefault()).toInstant());

        chart1.getAxes().getBottom().setMinMax(new DateTime(dateFrom.getTime()), new DateTime(dateTo.getTime()));
        chart1.getAxes().getLeft().setMinMax(-200, 2500);
        SwingWorker worker = new SwingWorker(){
            @Override
            protected Object doInBackground() throws Exception {
                try {
  
                    loadDemoData();
                } catch(Exception e) {
                    e.printStackTrace();
                }
                return null;
            }
            
            @Override
            protected void done() {
                try {
                    chart1.setAutoRepaint(false);
                    chart1.addSeries(lineSeries);        
                    chart1.setAutoRepaint(true);                            
                    nearestPointTool.setSeries(lineSeries);
                    nearestPointTool.setDrawLine(false);
                    nearestPointTool.getBrush().setColor(Color.RED);
                    nearestPointTool.getBrush().setVisible(true);
                    nearestPointTool.setStyle(NearestPointStyle.CIRCLE);
                    nearestPointTool.setSize(3);
                                            
                    //chart1.getTools().add(dynamicCursorTool);
                    dynamicCursorTool.getPen().setColor(Color.RED);
                    dynamicCursorTool.setSnap(true);
                    dynamicCursorTool.setActive(true);
                    dynamicCursorTool.getPen().setStyle(DashStyle.SOLID);
                    dynamicCursorTool.setSeries(lineSeries);
                    dynamicCursorTool.setStyle(CursorToolStyle.VERTICAL);
                    
                    dynamicCursorTool.addCursorListener((CursorEvent e) -> {
                        //date.setTime((long)e.getXValue());
                        //System.out.println("Cursor Position X: " +  df.format(date) + " Y: " + formatter.format(e.getPoint().getY()));
                    });                                                                           
                } catch(Exception e) {
                    e.printStackTrace();
                } 

                button.setEnabled(true);                           
            }            
        };
        worker.execute();
    }//GEN-LAST:event_buttonActionPerformed

    public void loadDemoData(){
  
        
        lineSeries.add( 1139906880000.0, 500);
        lineSeries.add(1139906940000.0, 2000);
        lineSeries.add(1139907000000.0, 0, Color.TRANSPARENT);    
        lineSeries.add(1139907060000.0, 0);
        lineSeries.add(1139907120000.0, 1);
        lineSeries.add(1139907180000.0, 0);
        lineSeries.add(1139907240000.0, 0);
        lineSeries.add(1139907300000.0, 0);
        lineSeries.add(1139907360000.0, 0);
        lineSeries.add(1139907420000.0, 0);
        lineSeries.add(1139907480000.0, 0);
      
       
    }
 

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(BedaFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(BedaFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(BedaFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(BedaFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new BedaFrame().setVisible(true);
        });
    }
        
    

    private final CursorTool dynamicCursorTool = new com.steema.teechart.tools.CursorTool();
    private final CursorTool staticCursorTool = new com.steema.teechart.tools.CursorTool();
    private final NearestPoint nearestPointTool = new com.steema.teechart.tools.NearestPoint();
    private final FastLine lineSeries = new com.steema.teechart.styles.FastLine();
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton button;
    private com.steema.teechart.TChart chart1;
    // End of variables declaration//GEN-END:variables
}




